﻿Type=Activity
Version=2.00
FullScreen=True
IncludeTitle=False
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim btnMapEnabled As Boolean
	Dim btnInformationEnabled As Boolean
	Dim btnPhotoEnabled As Boolean
	Dim btnPreviousEnabled As Boolean
	Dim btnNextEnabled As Boolean
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim lblAspect As Label
	Dim lblLocation As Label
	Dim lblCentre As Label
	Dim lblCountry As Label
	Dim lblLat As Label
	Dim lblLatitude As Label
	Dim lblLong As Label
	Dim lblLongitude As Label
	Dim scvInformation As ScrollView
	Dim lblInformation As Label
	lblInformation.Initialize("")
	Dim ivPhoto As ImageView
	Dim sv2dPhoto As ScrollView2D
	sv2dPhoto.Initialize(0, 0, "")
	Dim btnMap As Button
	Dim btnPrevious As Button
	Dim btnNext As Button
	Dim btnInformation As Button
	Dim btnPhoto As Button
				
	Dim scvInformationScrollPosition As Int
	scvInformationScrollPosition = 0
	Dim sv2dPhotoPanelWidth As Int
	sv2dPhotoPanelWidth = 0
	Dim sv2dPhotoPanelHeight As Int
	sv2dPhotoPanelHeight = 0
	Dim sv2dPhotoHorizontalScrollPosition As Int
	sv2dPhotoHorizontalScrollPosition = 0
	Dim sv2dPhotoVerticalScrollPosition As Int
	sv2dPhotoVerticalScrollPosition = 0
	Dim tmr As Timer
	Dim CursorAspect As Cursor
	Dim RowNumber As Int
	Dim StrUtil As StringUtils
End Sub

Sub Activity_Create(FirstTime As Boolean)
  Activity.LoadLayout("view") 'Load the view layout file.
 	ResizeViews
	scvInformation.Panel.AddView(lblInformation, _
	                                    0, _
																			0, _
																			scvInformation.Width, _
																			scvInformation.Height)
	lblInformation.Tag = "lblInformation"
	lblInformation.Color = Colors.Black
	lblInformation.TextColor = Colors.White
	Activity.AddView(sv2dPhoto, ivPhoto.Left, ivPhoto.Top, ivPhoto.Width, ivPhoto.Height)
	sv2dPhoto.Tag = "sv2dPhoto"
	Log("*******************")
	Dim i As Int
	For i = 0 To Activity.NumberOfViews-1
		Dim v As View
		v = Activity.GetView(i)
		Log(v.Tag&"("&v.Left&","&v.Top&","&v.Width&","&v.Height&")")
	Next
	Log("*******************")
	Dim query As String
	query = "Select _id, aspect, latitude, longitude, information, photo " & _
	        "FROM aspect " & _
	        "WHERE location_id = " & Main.LocationId & " " & _
					"ORDER BY _id"
	CursorAspect = Main.SQL1.ExecQuery(query)
	Log("CursorAspect.RowCount="&CursorAspect.RowCount)
	If CursorAspect.RowCount = 0 Then
		lblAspect.Text="No Aspect available"
		ToastMessageShow("No Aspect available", True)
		tmr.Initialize("tmr", 5000)
		tmr.Enabled = True
		StartActivity("Choose") 'Calls the Choose activity.
	End If
	CursorAspect.Position = 0
	RowNumber = 0
	SetPreviousNextButtons
	DisplayDetails
End Sub

Sub Activity_Resume
	ResizeViews
	lblInformation.SetLayout(scvInformation.Left, scvInformation.Top, scvInformation.Width, scvInformation.Height)
	scvInformation.ScrollPosition = scvInformationScrollPosition
  sv2dPhoto.Panel.Width = ivPhoto.Width
	sv2dPhoto.Panel.Height = ivPhoto.Height
	sv2dPhoto.HorizontalScrollPosition = sv2dPhotoHorizontalScrollPosition
	sv2dPhoto.VerticalScrollPosition = sv2dPhotoVerticalScrollPosition
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	scvInformationScrollPosition = scvInformation.ScrollPosition
	sv2dPhotoPanelWidth = sv2dPhoto.Panel.Width
	sv2dPhotoPanelHeight = sv2dPhoto.Panel.Height
	sv2dPhotoHorizontalScrollPosition = sv2dPhoto.HorizontalScrollPosition
	sv2dPhotoVerticalScrollPosition = sv2dPhoto.VerticalScrollPosition
End Sub

Sub tmr_Tick
	tmr.Enabled = False
	StartActivity("Choose") 'Calls the Choose activity.
End Sub

Sub btnInformation_Click
	StartActivity("DisplayInformation") 'Calls the DisplayInformation activity.		
End Sub

Sub btnPrevious_Click
	CursorAspect.Position = CursorAspect.Position - 1
	RowNumber = CursorAspect.Position	
	SetPreviousNextButtons
	DisplayDetails
End Sub

Sub btnMap_Click
	Main.CentreLatitude = Main.Latitude
	Main.CentreLongitude = Main.Longitude
	Main.LatitudeList.Initialize
	Main.LongitudeList.Initialize
	Main.LatitudeList.Add(Main.Latitude)
	Main.LongitudeList.Add(Main.Longitude)
	StartActivity("Map") 'Calls the Map activity.
End Sub

Sub btnNext_Click
	CursorAspect.Position = CursorAspect.Position + 1
	RowNumber = CursorAspect.Position
	SetPreviousNextButtons
	DisplayDetails
End Sub

Sub btnPhoto_Click
	StartActivity("DisplayPhoto") 'Calls the DisplayPhoto activity.		
End Sub

Sub DisplayDetails
	lblCountry.Text = Main.Country
	lblCentre.Text = Main.Centre
	lblLocation.Text = Main.Location
	Main.Aspect = CursorAspect.GetString("aspect")
	lblAspect.Text = Main.Aspect
	Main.Latitude = CursorAspect.GetString("latitude")
	lblLatitude.Text = Main.Latitude
	Main.Longitude = CursorAspect.GetString("longitude")
	lblLongitude.Text = Main.Longitude
	Log("Main.Country="&Main.Country)
	Log("Main.Centre="&Main.Centre)
	Log("Main.Location="&Main.Location)
	Log("Main.Aspect="&Main.Aspect)
	Log("Main.Latitude="&Main.Latitude)
	Log("Main.Longitude="&Main.Longitude)
	' Technique below copied from
	' LongTextSimple project
	Main.Information = CursorAspect.GetString("information")
	lblInformation.Text = Main.Information
	' Set the lblInformation height to measured height of text
  lblInformation.Height = StrUtil.MeasureMultilineTextHeight(lblInformation, lblInformation.Text)
	' Set the ScrollView internal Panel height to height of text
  scvInformation.Panel.Width = scvInformation.Width
	scvInformation.Panel.Height = lblInformation.Height
	Log("scvInformation.Panel("&scvInformation.Panel.Width&"," _
	                                  &scvInformation.Panel.Height&")")
	' set the scroll position to the top of the text
	' scvInformation.ScrollPosition = lblInformation.Top
  DoEvents ' needed to execute the previous line
  Log("scvInformation("&scvInformation.Left&"," _
	                            &scvInformation.Top&"," _
												      &scvInformation.Width&"," _
												      &scvInformation.Height&")")
	Log("lblInformation("&lblInformation.Left&"," _
	                       &lblInformation.Top&"," _
												 &lblInformation.Width&"," _
												 &lblInformation.Height&")")
	Log("***********************")														
	Dim buffer() As Byte 'declare an empty byte array
  buffer = CursorAspect.GetBlob("photo")
  Dim inputStream1 As InputStream
  inputStream1.InitializeFromBytesArray(buffer, 0, buffer.Length)
  Main.Photo.Initialize2(inputStream1)
  inputStream1.Close
  sv2dPhoto.Panel.Width = Main.Photo.Width
	sv2dPhoto.Panel.Height = Main.Photo.Height
	sv2dPhoto.Panel.SetBackgroundImage(Main.Photo)
  sv2dPhoto.HorizontalScrollPosition = 0
	sv2dPhoto.VerticalScrollPosition = 0
	Log("sv2dPhoto("&sv2dPhoto.Left&"," _
	                &sv2dPhoto.Top&"," _
	                &sv2dPhoto.Width&"," _
	                &sv2dPhoto.Height&")") 
	Log("sv2dPhotoPanel("&sv2dPhoto.Panel.Width&"," _
                       &sv2dPhoto.Panel.Height&")")
	Log("ivPhoto("&ivPhoto.Left&"," _
	                     &ivPhoto.Top&"," _
	                     &ivPhoto.Width&"," _
											 &ivPhoto.Height&")")
	Log("*******************")
	Log("Main.Photo("&Main.Photo.Width&","&Main.Photo.Height&")")
	' ivPhoto.Bitmap = Main.Photo
	' ivPhoto.Gravity = Gravity.CENTER
	Log("*******************")
End Sub

Sub ResizeViews
  ' Technique below taken from
	' ProbCalc project
	If 100%X < 100%Y Then 
'For Portrait, sets geometry of the views.
lblAspect.SetLayout(0%X,0%Y,50%X,6.25%Y)
lblLocation.SetLayout(0%X,6.25%Y,50%X,6.25%Y)
lblCentre.SetLayout(0%X,12.5%Y,50%X,6.25%Y)
lblCountry.SetLayout(0%X,18.75%Y,50%X,6.25%Y)
lblLat.SetLayout(65.625%X,0%Y,34.375%X,6.25%Y)
lblLatitude.SetLayout(65.625%X,6.25%Y,34.375%X,6.25%Y)
lblLong.SetLayout(65.625%X,12.5%Y,34.375%X,6.25%Y)
lblLongitude.SetLayout(65.625%X,18.75%Y,34.375%X,6.25%Y)
scvInformation.SetLayout(0%X,25%Y,65.625%X,41.6666666666667%Y)
btnMap.SetLayout(65.625%X,25%Y,34.375%X,10.4166666666667%Y)
btnInformation.SetLayout(65.625%X,56.25%Y,34.375%X,10.4166666666667%Y)
ivPhoto.SetLayout(0%X,67.6666666666667%Y,65.625%X,32.3333333333333%Y)
btnPhoto.SetLayout(65.625%X,66.6666666666667%Y,34.375%X,10.4166666666667%Y)
btnPrevious.SetLayout(65.625%X,79.1666666666667%Y,34.375%X,10.4166666666667%Y)
btnNext.SetLayout(65.625%X,89.5833333333333%Y,34.375%X,10.4166666666667%Y)
  Else
'For Landscape, sets geometry of the views.
lblAspect.SetLayout(0%X,0%Y,43.75%X,9.375%Y)
lblLocation.SetLayout(0%X,9.375%Y,43.75%X,9.375%Y)
lblCentre.SetLayout(0%X,18.75%Y,43.75%X,9.375%Y)
lblCountry.SetLayout(0%X,28.125%Y,43.75%X,9.375%Y)
lblLat.SetLayout(43.75%X,0%Y,22.9166666666667%X,9.375%Y)
lblLatitude.SetLayout(66.6666666666667%X,0%Y,33.3333333333333%X,9.375%Y)
lblLong.SetLayout(43.75%X,9.375%Y,22.9166666666667%X,9.375%Y)
lblLongitude.SetLayout(66.6666666666667%X,9.375%Y,33.3333333333333%X,9.375%Y)
scvInformation.SetLayout(43.75%X,18.75%Y,56.25%X,68.75%Y)
ivPhoto.SetLayout(0%X,37.5%Y,43.75%X,50%Y)
btnMap.SetLayout(0%X,87.5%Y,20.8333333333333%X,12.5%Y)
btnPhoto.SetLayout(20.8333333333333%X,87.5%Y,22.9166666666667%X,12.5%Y)
btnInformation.SetLayout(43.75%X,87.5%Y,18.75%X,12.5%Y)
btnPrevious.SetLayout(62.5%X,87.5%Y,18.75%X,12.5%Y)
btnNext.SetLayout(81.25%X,87.5%Y,18.75%X,12.5%Y)
  End If
End Sub

Sub SetPreviousNextButtons
	If RowNumber = 0 Then
		btnPrevious.Enabled = False
	Else
		btnPrevious.Enabled = True
	End If
	If RowNumber + 1 = CursorAspect.RowCount Then
		btnNext.Enabled = False
	Else
		btnNext.Enabled = True
	End If
End Sub
